#include "Hello.h"
#include <stdio.h>

extern "C" {
  #include "qsk_bsp.h"          // include QSK board support package
}

void mcu_init(void);

unsigned int ticks_100ms = 0;	// this value will be incemented every 100 ms

int main()
{

  mcu_init();
  
  Hello *h = new Hello();
  h->greeting();
  
  Hello hora;
  
  hora.setHr(10);
  ++hora;
  int i = hora.getHr();
  char t[8];
  sprintf(t, "%2d:%2d:%2d", i, i+1, i+2);
  DisplayString(0,t);
    
  while(S1 && S2 && S3);
  delete h;
  return 0;
}


void mcu_init(void)
{
    prc0 = 1;     /* Enable writes to clock control registers */
    cm21 = 0;     /* Switch from Ring osc to Xin (10 Mhz/8) */
    cm16 = 1;     /* Set CM16 & CM17 to 0, divide-by-1 mode */
    cm17 = 1;
    cm06 = 1;     /* Enable CM16 & CM17, clock is divide-by-1 mode */
    prc0 = 0;     /* Disable writes to clock register */
    prc2 = 1;     /* Enable writes to the Pin Assignment Control reg(PACR) */
    pacr = 0x04;  /* Use this line of code for 48 pin package */

  {
    prc1 = 1;                       /* enable access to processor mode registers */
    pm20 = 0;                       /* 2 wait states for sfr access...this is the reset value
                                       necessary for >16Mhz operation, can be set to 1 wait for <=16Mhz */
    prc1 = 0;                       /* disable access to processor mode registers */
  }

  {
    /* configure and switch main clock to PLL at 20MHz */
	/* and start the 32Khz crystal sub clock */
    unsigned int count = 20000;
    prc0 = 1;                       /* enable access to clock registers */
    cm1 = 0x20;                     /* set to hi-drive Xin, divide by 1 */
    cm0 = 0x18;                     /* set to main clock using divide by 1, Xc function */
    								/* Also turn on 32kHz sub clock and Xc high drive */
    cm21 = 0;                       /* switch to Xin */
    plc0 = 0x11;                    /* configure PLL to x2 */
    plc0 = 0x91;                    /* enable PLL */
    while(count > 0) count--;       /* wait for PLL and 32kHz clocks to stabilize (20mS maximum, 200,000 cycles @10Mhz)
                                       this decrement with no optimization is 12 cycles each (20,000*12 cycles=240,000=24mS) */
    cm11 = 1;                       /* switch to PLL */
    prc0 = 0;                       /* disable access to clock registers */
  }
  
   // Switch initialization - macro defined in skp_bsp.h
  ENABLE_SWITCHES

}
